package test;

import javax.persistence.CascadeType;
import javax.persistence.Entity;
import javax.persistence.GeneratedValue;
import javax.persistence.Id;
import javax.persistence.JoinColumn;
import javax.persistence.NamedNativeQuery;
import javax.persistence.OneToOne;
import javax.persistence.SequenceGenerator;
import javax.persistence.Table;

/**
 * @author hhildebrand
 * 
 */
@Entity
@Table(name = "relationship", schema = "test")
@SequenceGenerator(schema = "test", name = "relationship_id_seq", allocationSize = 1)
@NamedNativeQuery(name = "relationship.getAll", query = "select r from test.get_relationships() as r", resultClass = Relationship.class)
public class Relationship {

    @Id
    @GeneratedValue(generator = "relationship_id_seq")
    private Long         id;

    @OneToOne(cascade = CascadeType.ALL)
    @JoinColumn(name = "inverse")
    private Relationship inverse;

    private String       name;

    public Long getId() {
        return id;
    }

    public void setId(Long id) {
        this.id = id;
    }

    public Relationship getInverse() {
        return inverse;
    }

    public void setInverse(Relationship i) {
        this.inverse = i;
        i.inverse = this;

    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }
}
