package test;

import static junit.framework.Assert.assertNotNull;
import static junit.framework.Assert.assertTrue;

import java.util.List;
import java.util.Properties;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;
import javax.persistence.Persistence;

import org.junit.Test;

/**
 * @author hhildebrand
 * 
 */
public class TestRelationship {

    @Test
    /**
     * Failure converting result of native query to correct entity type
     */
    public void testFunction() throws Exception {
        Properties properties = new Properties();
        properties.load(getClass().getResourceAsStream("/jpa.properties"));
        EntityManagerFactory emf = Persistence.createEntityManagerFactory("test",
                                                                          properties);
        EntityManager em = emf.createEntityManager();

        em.getTransaction().begin();

        Relationship r = new Relationship();
        r.setName("foo");

        em.persist(r);

        Relationship i = new Relationship();
        i.setName("bar");

        em.persist(i);

        r.setInverse(i);

        em.getTransaction().commit();

        em.clear();

        em.getTransaction().begin();

        List<Relationship> relations = em.createNamedQuery("relationship.getAll",
                                                           Relationship.class).getResultList();

        assertNotNull(relations);

        assertTrue(relations.size() > 0);

        em.getTransaction().commit();
    }
}
